/***********************************************************************
	Place the constraint clb for VEB
***********************************************************************/
#include <string.h>
#include <stdio.h>
#include "util.h"
#include "vpr_types.h"
#include "globals.h"
#include "constraint_placement.h"
#include <assert.h>

void get_veb_block()
{

}


void initial_constraint_placement(int * located)
{
	int i,j, k, m;
	int *veb_block_list;
	int veb_height, veb_width;
	int veb_lx, veb_ly;
	int block_x, block_y;	//the absolute position of the block

	int *veb_block;			//the non constrainted block in veb (not carry head)
	int block_count;				//the count for veb_block
	int *veb_carry_head;	//the non constrainted carry head in veb
	int veb_carry_head_count;	//the count for non constrainted carry head in veb

	int check_result;

	struct s_pos {int x; int y;} *pos; 
	int lastx, lasty;
	int x, y;
	int pos_count;
	int choice;
	int ok;


	//initial all the block become not fixed
	printf("initial_constraint_placement \n");
	for (i=0;i<num_blocks;i++)
		block[i].fixed = 0;
	
	/*********************************************************************************************/
	//first place all fixed area and constrainted lower left veb

	printf("number_module %d \n", number_module);
	for (i=0; i< number_module; i++)
	{
		//read all veb constraint
		printf("constraint[%d].veb_index %d \n", i, constraint[i].veb_index);
		if (constraint[i].veb_index > 0)
		{
			//not consider the top module
			veb_height = constraint[i].height;
			veb_width = constraint[i].width;
			veb_lx = constraint[i].lx;
			veb_ly = constraint[i].ly;

			if ( (veb_height > -1) && (veb_width > -1))
			{
				//there is area constraint 
				if (constraint[i].constraint_lower_corner)
				{
					//there is lower left constraint

					check_result = check_veb_place_valid(veb_lx, veb_ly, veb_width, veb_height, constraint[i].veb_index);
					// return result
					//	0 : the veb is placed within FPGA and not overlap with another clb (another veb)
					//	1 : the veb is placed out of FPGA
					//	2 : the veb overlapped with DSP or Memory or EMB
					//	3 : the veb overlapped with fixed clb 
					//	4 : the veb overlapped with non fixed clb
					//	5 : the veb overlapped with another veb

					if (check_result != 0) 
					{
						printf("The user constraint veb %s is outside the FPGA or overlapping with DSP/MEMORY/Other CLB \n",constraint[i].name);
						printf("Check result = %d \n", check_result);
						printf("veb_lx = %d, veb_ly = %d, veb_width = %d, veb_height = %d, veb_index = %d\n", veb_lx, veb_ly, veb_width, veb_height, constraint[i].veb_index);
						exit(1);
					}
										
					//Place normal non constrainted block in VEB
					//search all block and find the blocks belong to that veb
					veb_block = (int *) malloc(sizeof (int));					
					veb_carry_head = (int *) malloc(sizeof(int));					


					find_veb_block(&veb_block, &block_count, &veb_carry_head, &veb_carry_head_count, constraint[i].veb_index, located);


					//store the available position with veb
					pos = (struct s_pos *) malloc(veb_width * veb_height * sizeof(struct s_pos));

					//printf("veb carry head count = %d, veb block_count = %d \n", veb_carry_head_count, block_count);

					//get the available space in veb
					pos_count = 0;					
					for (k=0;k<veb_width;k++) {
						for (m=0;m<veb_height;m++) {
							if ((clb[k+veb_lx][m+veb_ly].type == CLB) || (clb[k+veb_lx][m+veb_ly].type == EMB) )
							{
								if (clb[k+veb_lx][m+veb_ly].occ == 0) {
									pos[pos_count].x = k+veb_lx;	//store the absolute position 
									pos[pos_count].y = m+veb_ly;
									pos_count++;
								}
							}
						}
					}


					//second handle the remaining block in veb
					for (j= 0; j< block_count; j ++)
					{
						k = veb_block[j];
						choice =0; 

						clb[pos[choice].x][pos[choice].y].occ = 1;
						clb[pos[choice].x][pos[choice].y].empty = 0;
						clb[pos[choice].x][pos[choice].y].u.block = k;
						clb[pos[choice].x][pos[choice].y].module_index = block[k].module_index;
						clb[pos[choice].x][pos[choice].y].iconstraint = i;
						clb[pos[choice].x][pos[choice].y].type = EMB;
						//block[k].fixed = 1;	//fix the block , it won't be moved away
						block[k].fixed = constraint[i].fixed;	//fix the block , it won't be moved away
						located[k] = 1;									

						//printf("emb block %d (%s) put in position x= %d, y=%d \n", k, block[k].name, pos[choice].x, pos[choice].y);
						
						// Ensure randomizer doesn't pick this block again 
						pos[choice] = pos[pos_count-1];   // overwrite used block position
						pos_count--;										
					}

					//assign the empty clb to the veb
					for (k=0;k<veb_width;k++) 
					{
						for (m=0;m<veb_height;m++) 
						{
							if ((clb[k+veb_lx][m+veb_ly].type == CLB) || (clb[k+veb_lx][m+veb_ly].type == EMB) )
							{
								if (clb[k+veb_lx][m+veb_ly].occ == 0) 
								{
									clb[k+veb_lx][m+veb_ly].occ = 0;
									clb[k+veb_lx][m+veb_ly].module_index = constraint[i].veb_index;
									clb[k+veb_lx][m+veb_ly].iconstraint = i;
									clb[k+veb_lx][m+veb_ly].empty = 0;																		
									clb[k+veb_lx][m+veb_ly].type = EMB;																		
								}
							}
						}
					}


					free(veb_block);
					free(veb_carry_head);
					free(pos);
				}
			}
		}
	}
	/*********************************************************************************************/
			
	/*********************************************************************************************/
	//place the normal constrainted clb

	printf("========================================================== \n");
	printf("Place block to clb : \n");
	for (i=0; i< num_blocks; i++)
	{
		//all normal clb block
		if (block[i].module_index == 0)
		{		
			//printf("block[%d] to clb[%d][%d], block_fix :%d \n", i, block[i].rx, block[i].ry, block[i].fixed);
			if ( (block[i].rx > 0) && (block[i].ry >0))
			{				
				//fixed block 
				if (clb[block[i].rx][block[i].ry].type == CLB) 
				{
					if (clb[block[i].rx][block[i].ry].occ == 0) 
					{
						clb[block[i].rx][block[i].ry].u.block = i;
						clb[block[i].rx][block[i].ry].occ = 1;
						clb[block[i].rx][block[i].ry].module_index = block[i].module_index;
						clb[block[i].rx][block[i].ry].empty = 0;	
						block[i].fixed = 1;
						located[i] = 1;							
						printf("block[%d] to clb[%d][%d] \n", i, block[i].rx, block[i].ry);
					}
					else
					{
						printf("Error: placing constrained block %s to clb[%d][%d] \n", block[i].name, block[i].rx, block[i].ry);
						exit(0);
					}
				}
				else
				{
					printf("Error: placing constrained block %s to clb[%d][%d] which is not CLB \n", block[i].name, block[i].rx, block[i].ry);
					exit(0);
				}
								
				if (block[i].carry_head)
				{
					//it is carry head of the carry chain
					//need to fix all the carry body 
					lastx = block[i].rx;
					lasty = block[i].ry;

					pos_count =  block[i].carryout_cluster;
					//loop all carry body
					while (pos_count != -1)
					{
						x = lastx;
						y = lasty + 1;	//next vertical clb
						if (y > ny)
						{
							printf("Error : user constrainted carry chain is out of FPGA \n");
							exit (1);
						}				

						if (clb[x][y].type == CLB) 
						{
							if (clb[x][y].occ == 0) 
							{
								clb[x][y].u.block = pos_count;
								clb[x][y].occ = 1;
								clb[x][y].module_index = block[pos_count].module_index;
								clb[x][y].empty = 0;	
								block[pos_count].fixed = 1;
								block[pos_count].rx = x;
								block[pos_count].ry = y;
								located[pos_count] = 1;							
								//clb[x][y].type = EMB;	
								//printf("block[%d] to clb[%d][%d] \n", pos_count, block[pos_count].rx, block[pos_count].ry);
							}
						}

						pos_count =  block[pos_count].carryout_cluster;
						lastx = x;
						lasty = y;
					}

				}
			}
		}
	}

}

int check_veb_place_valid(int x, int y, int width, int height, int veb_index)
{
	//check 1. the veb overlap with dsp or memory
	//		2. the veb is within FPGA
	//		3. overlap with another veb

	//Return:
	//	0 : the veb is placed within FPGA and not overlap with another clb (another veb)
	//	1 : the veb is placed out of FPGA
	//	2 : the veb overlapped with DSP or Memory or EMB
	//	3 : the veb overlapped with fixed clb 
	//	4 : the veb overlapped with non fixed clb
	//	5 : the veb overlapped with another veb

	
	int i,j;

	//check the veb is within FPGA or not
	if ( ((x + width -1) > (nx)) || ((y + height -1) > ny))
	{
		//the veb is out of FPGA
		return 1;
	}

	for (i = 0; i<width; i++)
	{
		for (j = 0; j<height ; j++)
		{
			//check one row only 
			//if (clb[x + i][y + j].type != CLB)
			if (clb[x + i][y + j].type != EMB)
			{
				//it overlap with DSP or MEMORY or EMB
				return 2;
			}
			else
			{
				//the space is CLB
				if ( (clb[x + i][y + j].module_index != veb_index) && (clb[x + i][y + j].occ == 1))
				{
					//the clb is not occupied by this veb
					if (block[clb[x + i][y + j].u.block].fixed == 1)
					{
						//the clb is fixed and can't be moved away
						return 3;
					}
					else if (clb[x + i][y + j].occ == 1)
					{
						//the clb is occupied by another block
						return 4;
					}
					else if (clb[x + i][y + j].module_index > 0)
					{
						//the veb is overlap with another veb
						return 5;
					}
				}
			}
		}
	}

	return 0;
}

void check_veb_carry_chain_valid(int head_x, int head_y, int veb_width, int veb_height, int chain_length, char *veb_name)
{
	//check the block's position is within the VEB area or not
	if ((head_x< 0) || (head_x > (veb_width)) 
		|| (head_y < 0) || (head_y > (veb_height)))
	{
		printf("Error placing carry chains in VEB %s.  The chain head is outside the veb area\n", veb_name);
		exit(1);
	}							

	//check the height of the carry chain is over the veb area or not 
	//the block is constrainted in a particular position
							
	if ( (head_y + chain_length) > veb_height)
	{
		//the lenght of the carry is exceed the height of the veb
		printf("Error placing carry chains in VEB %s.  Re-run with a larger array\n", veb_name);
		exit(1);
	}
}

int check_veb_carry_chain_overlap(int head_x, int head_y, int veb_width, int veb_height, int veb_lx, int veb_ly, int chain_length)
{
	int i;
	
	//check the chain exceed the veb or not
	if ( (head_y + chain_length) > (veb_ly + veb_height))
	{
		return 0;
	}

	//check the carry chain's clb is occupied by another block or not
	for (i= 0; i < chain_length; i++)
	{
		if (clb[head_x][head_y + i].occ == 1)
		{
			return 0;
		}
	}
	
	return 1;
}


int check_veb_block_valid(int block_x, int block_y, int veb_lx, int veb_ly, int veb_width, int veb_height)
{
	//check the block placed is valid or not 
	//return 
	//	0 : the block is plaeced without problem
	//	1 : the block is outside the FPGA
	//	2 : the block is outside the VEB
	//  3 : the block is placed on memory or DSP
	//  4 : the block is placed on occupied clb



	//check the block is outside FPGA or not
	if ((block_x< 0) || (block_x > nx) 
		|| (block_y < 0) || (block_y > ny))
	{	
		return(1);
	}							

	//check the block's position is within the VEB area or not
	if ((block_x< veb_lx) || ( block_x > (veb_lx + veb_width)) 
		|| (block_y < veb_ly) || (block_y > (veb_ly + veb_height)))
	{
		return(2);
	}		

	//check the position of the block is placed on CLB , not memory or DSP
	if (clb[block_x][block_y].type != CLB)
	{	
		return(3);
	}

	if (clb[block_x][block_y].occ == 1)
	{
		//the clb is already occupied by other block		
		return(4);
	}

	return(0);
}



void find_veb_block(int **veb_block, int *block_count, int **veb_carry_head, int *carry_head_count, int veb_index, int *located)
{
	//find the non constrainted block and carry head block for the veb_index
	int i;

	(*block_count) =0;
	(*carry_head_count) =0;

	for (i=0; i<num_blocks; i++)
	{
		if (block[i].module_index == veb_index)
		{
			if (located[i] == 0)
			{
				//the block is belong to the veb_index
				if (block[i].carry_head)
				{								
					//it is the carry head
					(*carry_head_count) ++;
					(*veb_carry_head) =(int *) realloc( (*veb_carry_head), (*carry_head_count) * sizeof(int));
					(*veb_carry_head)[(*carry_head_count)-1] = i;
				}
				else if (!block[i].carry_body)
				{
					//carry body is not saved to the list

					(*block_count) ++;
					(*veb_block) =(int *) realloc((*veb_block), (*block_count) * sizeof(int));
					(*veb_block)[(*block_count)-1] = i;				
				}
			}
		}
	}
}






