 /*------------------------------------------------------------
  *  Copyright 2002 By Kara K.W. Poon and Steve Wilton
  *
  * Permission to use, copy, and modify this software and its documentation
is
  * hereby granted only under the following terms and conditions.  Both the
  * above copyright notice and this permission notice must appear in all
copies
  * of the software, derivative works or modified versions, and any portions
  * thereof, and both notices must appear in supporting documentation.
  * Permission is granted ONLY for non-commercial use.  For
  * commercial use, please contact the authors.
  *
  * This software may be distributed (but not offered for sale or
transferred
  * for compensation) to third parties, provided such third parties agree to
  * abide by the terms and conditions of this notice.
  *
  * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHORS, AS
  * WELL AS THE UNIVERSITY OF BRITISH COLUMBIA AND THE
  * UNIVERSITY OF TORONTO DISCLAIM ALL WARRANTIES WITH
  * REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL THE
  * AUTHORS OR THE UNIVERSITY OF BRITISH COLUMBIA OR THE
  * UNIVERSITY OF TORONTO BE LIABLE FOR ANY SPECIAL, DIRECT,
  * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
  * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
  * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
  * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  *------------------------------------------------------------*/
/*
  VPR was first written by Vaugh Betz at the University of 
  Toronto. Descriptions on different versions of VPR is available
  in the descript.txt file.

  The power model is an extension of the original VPR. This 
  feature is added by Kara Poon at the University of British 
  Columbia as a master thesis project supervised by Dr. Steve
  Wilton.

 */


/* Netlist to be placed stuff. */
extern int num_nets, num_blocks;     
extern int num_p_inputs, num_p_outputs, num_clbs, num_globals, num_memory, num_dsp;
extern struct s_net *net;
extern struct s_block *block;
extern boolean *is_global;
extern float avg_activity;
extern float max_activity;
extern float cap_norm_fac;

/* Physical FPGA architecture stuff */
extern int nx, ny, io_rat, pins_per_clb, num_global_clock;
extern int subblock_num_pin;
extern int pins_per_memory, pins_per_dsp;
extern int **pinloc;
extern int *clb_pin_class;
extern int **pinloc_memory;
extern int *memory_pin_class;
extern double *memory_pin_cap;
extern enum e_memory_pin_type *memory_pin_type;
extern int **pinloc_dsp;
extern int *dsp_pin_class;
extern double *dsp_pin_cap;
extern int *memory_is_output_pin;
extern int *dsp_is_output_pin;
extern boolean *is_global_clb_pin;
extern boolean *is_global_memory_pin;
extern boolean *is_global_dsp_pin;
extern struct s_class *class_inf;
extern struct s_class *class_inf_memory;
extern struct s_class *class_inf_dsp;
extern int num_class;
extern int num_class_dsp;
extern int num_class_memory;
extern struct clock_details *clock_inf;
extern struct memory_details *memory_inf;
extern struct dsp_details *dsp_inf;

extern float dsp_internal_delay;
extern float memory_internal_delay;

/* chan_width_x is the x-directed channel; i.e. between rows */
extern int *chan_width_x, *chan_width_y; /* numerical form */
extern struct s_clb **clb;

/* [0..num_nets-1] of linked list start pointers.  Defines the routing.  */
extern struct s_trace **trace_head, **trace_tail;   

/* Structures to define the routing architecture of the FPGA.           */
extern int num_rr_nodes;
extern t_rr_node *rr_node;                   /* [0..num_rr_nodes-1]          */
extern int num_rr_indexed_data;
extern t_rr_indexed_data *rr_indexed_data;   /* [0 .. num_rr_indexed_data-1] */
extern int **net_rr_terminals;             /* [0..num_nets-1][0..num_pins-1] */
extern struct s_switch_inf *switch_inf; /* [0..det_routing_arch.num_switch-1] */
extern int **rr_clb_source;              /* [0..num_blocks-1][0..num_class-1] */
extern int operation_temperature;
extern int num_temperature_records;      /*Number of different temperatures 
														 in .arch file */
extern struct temperature_record *NFS_records; /* [0..num_temperature_records]*/
extern struct transistor_record NMOS_tx_record;
extern struct transistor_record PMOS_tx_record;
extern struct poly_record poly_inf;
extern float swing_voltage;
extern float supply_voltage;
extern float Vgs_for_leakage;
extern float SRAM_leakage;
extern float short_circuit_power_percentage;

extern t_P_dsp P_dsp;
extern t_P_memory P_memory;

int ignore_carry_chains;

extern struct user_constraint *constraint;
extern int number_module;
extern int num_emb;
extern int route_through;
extern int emb_allow_switch;

extern struct wide_segment_inf  wide_seg; 
extern int is_wide_seg; 


