 /*----------------------------------------------------------------------------
  *  Copyright 2002 By Kara K.W. Poon and Steve Wilton
  *
  * Permission to use, copy, and modify this software and its documentation is
  * hereby granted only under the following terms and conditions.  Both the
  * above copyright notice and this permission notice must appear in all copies
  * of the software, derivative works or modified versions, and any portions
  * thereof, and both notices must appear in supporting documentation.
  * Permission is granted ONLY for non-commercial use.  For
  * commercial use, please contact the authors.
  *
  * This software may be distributed (but not offered for sale or transferred
  * for compensation) to third parties, provided such third parties agree to
  * abide by the terms and conditions of this notice.
  *
  * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHORS, AS
  * WELL AS THE UNIVERSITY OF BRITISH COLUMBIA AND THE
  * UNIVERSITY OF TORONTO DISCLAIM ALL WARRANTIES WITH
  * REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL THE
  * AUTHORS OR THE UNIVERSITY OF BRITISH COLUMBIA OR THE
  * UNIVERSITY OF TORONTO BE LIABLE FOR ANY SPECIAL, DIRECT,
  * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
  * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
  * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
  * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  *----------------------------------------------------------------------------*/
/*
  VPR was first written by Vaugh Betz at the University of 
  Toronto. Descriptions on different versions of VPR is available
  in the descript.txt file.

  The power model is an extension of the original VPR. This 
  feature is added by Kara Poon at the University of British 
  Columbia as a master thesis project supervised by Dr. Steve
  Wilton.

 */

float **alloc_and_load_timing_graph (t_timing_inf timing_inf, t_subblock_data
       subblock_data); 

t_linked_int *allocate_and_load_critical_path (void);

void load_timing_graph_net_delays (float **net_delay);

float load_net_slack (float **net_slack, float target_cycle_time); 

void free_timing_graph (float **net_slack);

void free_subblock_data (t_subblock_data *subblock_data_ptr);

void free_clock_inf(struct clock_details *clock_inf_ptr);

void free_temperature_record (struct temperature_record *temperatur_record_ptr);

void print_timing_graph (char *fname);

void print_net_slack (char *fname, float **net_slack); 

void print_critical_path (char *fname);

void get_tnode_block_and_output_net (int inode, int *iblk_ptr, int *inet_ptr);

void do_constant_net_delay_timing_analysis (t_timing_inf timing_inf,
        t_subblock_data subblock_data, float constant_net_delay_value);
