 /*----------------------------------------------------------------------------
  *  Copyright 2002 By Kara K.W. Poon and Steve Wilton
  *
  * Permission to use, copy, and modify this software and its documentation is
  * hereby granted only under the following terms and conditions.  Both the
  * above copyright notice and this permission notice must appear in all copies
  * of the software, derivative works or modified versions, and any portions
  * thereof, and both notices must appear in supporting documentation.
  * Permission is granted ONLY for non-commercial use.  For
  * commercial use, please contact the authors.
  *
  * This software may be distributed (but not offered for sale or transferred
  * for compensation) to third parties, provided such third parties agree to
  * abide by the terms and conditions of this notice.
  *
  * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHORS, AS
  * WELL AS THE UNIVERSITY OF BRITISH COLUMBIA AND THE
  * UNIVERSITY OF TORONTO DISCLAIM ALL WARRANTIES WITH
  * REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL THE
  * AUTHORS OR THE UNIVERSITY OF BRITISH COLUMBIA OR THE
  * UNIVERSITY OF TORONTO BE LIABLE FOR ANY SPECIAL, DIRECT,
  * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
  * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
  * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
  * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  *----------------------------------------------------------------------------*/
/*
  VPR was first written by Vaugh Betz at the University of 
  Toronto. Descriptions on different versions of VPR is available
  in the descript.txt file.

  The power model is an extension of the original VPR. This 
  feature is added by Kara Poon at the University of British 
  Columbia as a master thesis project supervised by Dr. Steve
  Wilton.

 */
void read_arch 
(
 char *arch_file, 
 enum e_route_type route_type,
 struct s_det_routing_arch *det_routing_arch, 
 t_segment_inf **segment_inf_ptr, 
 t_timing_inf *timing_inf_ptr, 
 t_subblock_data *subblock_data_ptr, 
 t_chan_width_dist *chan_width_dist_ptr,
 char do_power
); 

void init_arch (float aspect_ratio, boolean user_sized);

void print_arch (char *arch_file, enum e_route_type route_type,
       struct s_det_routing_arch det_routing_arch, t_segment_inf *segment_inf, 
       t_timing_inf timing_inf, t_subblock_data subblock_data,
       t_chan_width_dist chan_width_dist); 

int calc_num_buffer_stages(float FO, float desired_stage_effort);

float calc_buffer_stage_effort(int N, float FO);

